import processing.serial.*;
Serial myPort;

int v,v0,xpos;
int screen_height,screen_width;
PFont font;
long st,st0;
String port;
String Data[];
int dcnt=0;
double temp;

void setup(){
  port="COM33";
  myPort=new Serial(this,port,9600);
  screen_width=900;
  screen_height=400;
  size(screen_width,screen_height);
  font = loadFont("AgencyFB-Reg-24.vlw");
  xpos=0;
  redraw();
  Data=new String[3600];
}

void draw(){  
  st=millis()/1000;
  if(st!=st0){
  
    stroke(255, 255, 255); 
    fill(255, 255, 255); 
    rect(0, 0, 100, 30);
    
    textFont(font,24);
    fill(0, 102, 153);
    text(v, 10, 30);
    
    String str;
    str=dcnt+","+temp;
    Data[dcnt]=str;   
    dcnt++;       
    st0=st;
    
    if(dcnt%10==0){
      str=" , ";
      Data[dcnt]=str;
      saveStrings("result.csv", Data);
    }
  }
}

void redraw(){
  background(255);
  stroke(0, 0, 0); 
  fill(255, 255, 255); 
  rect(240, 0, 360, 400);
}

void serialEvent(Serial p){
  if(myPort.available()>1){
    v0=v;
    int v_high = myPort.read();
    int v_low = myPort.read(); 
    v = v_high * 256 + v_low;
    temp=(double)v/100;
    v=v/10;
    stroke(255, 100, 100); 
    line(xpos-1,screen_height-v0,xpos,screen_height-v);
    xpos++;
    if(xpos>screen_width){xpos=0;redraw();}
  } 
}
