
import processing.serial.*;
Serial myPort;

int v,v0,v00,v000;
int r;
int xpos;
int screen_height,screen_width;
PFont font;
String lines[];
long t,t0,st,st0;
int IBI,PVA;
float HR;
String Data[];
int dcnt=0;

void setup(){
  lines = loadStrings("settings.txt"); 
  myPort=new Serial(this,lines[0],9600);
  
  screen_width=int(lines[1]);
  screen_height=int(lines[2]);
  size(screen_width,screen_height);
  xpos=0;
  
  font = loadFont("AgencyFB-Reg-24.vlw");
  redraw();
  t=0;t0=0;
  Data=new String[3600];
}

void draw(){
  
  st=millis()/1000;
  if(st!=st0){
    String str;
    str=HR+","+PVA;
    Data[dcnt]=str;
    //saveStrings("result.txt", str); 
    st0=st;
    dcnt++;       

    stroke(255, 255, 255); 
    fill(255, 255, 255); 
    rect(0, 60, 100, 30);
    textFont(font,24);
    fill(0, 102, 153);
    text(dcnt, 10, 90);
    stroke(255, 100, 100); 
    
    
    if(dcnt%10==0){
      str=" , ";
      Data[dcnt]=str;
      saveStrings("result.csv", Data);
    }
  }
}

void redraw(){
  background(255);
  stroke(255, 100, 100); 
  textFont(font,24);
  fill(0, 102, 153);
  text("ArduChart", 10, 30); 
  text(lines[0], 10, 60); 
}

void serialEvent(Serial p){
  if(myPort.available()>1){
    v000=v00;
    v00=v0;
    v0=v;
    int v_high = myPort.read();
    int v_low = myPort.read(); 
    v = v_high * 256 + v_low;
    
    line(xpos-1,screen_height-v0,xpos,screen_height-v);
    xpos++;
    
    if((v-v0)<0 && (v0-v00)>=0){
      t0=t;
      t=millis();
      IBI=int(t-t0);
      HR=(60000/IBI);
      PVA=v;
      textFont(font,12);
      fill(255, 0, 0);
      text(int(HR),xpos-1,screen_height-v0); 
      fill(0, 255, 0);
      text(int(PVA),xpos-1,screen_height-v0-15); 
    }
    
    if(xpos>screen_width){xpos=0;redraw();}
  } 
}
